<?php

if ( ! defined( 'xinmag_VERSION' ) )
	define( 'xinmag_VERSION', '1.0.0' );
	
add_action( 'after_setup_theme', 'xinmag_setup' );
if ( ! function_exists( 'xinmag_setup' ) ):
function xinmag_setup() {
	global $content_width;
	if ( ! isset( $content_width ) ) 
		$content_width = 940;

	add_theme_support( 'post-thumbnails' );
	add_theme_support( 'automatic-feed-links' );
	add_theme_support( 'post-formats', array( 'aside', 'link', 'quote' ) );

	load_theme_textdomain( 'xinmagmag', get_template_directory() . '/languages' );
	add_editor_style();
	add_theme_support( 'custom-background', array(
		'default-color' => '', //Default background color
	) );
	$custom_header_support = array(
		'default-image'		=> get_template_directory_uri() . '/images/logo.png',
		'flex-width'        => true,
		'flex-height'		=> true,
	    'header-text'		=> true,
		'default-text-color' => '000000',		
		'width' 			=> apply_filters( 'xinmag_header_image_width', 300 ),
		'height' 			=> apply_filters( 'xinmag_header_image_height', 110 ),
		// Callback for styling the header.
		'wp-head-callback' => 'xinmag_header_style',
		// Callback for styling the header preview in the admin.
		'admin-head-callback' => 'xinmag_admin_header_style',
		// Callback used to display the header preview in the admin.
		'admin-preview-callback' => 'xinmag_admin_header_image',
	);
	add_theme_support( 'custom-header', $custom_header_support );	
	register_default_headers( array(
		'header' => array(
			'url' => '%s/images/logo.png',
			'thumbnail_url' => '%s/images/logo.png',
			'description' => __( 'Logo', 'xinmag' )
		),
	) );
	
	remove_filter('term_description','wpautop');
						
	register_nav_menus( array(
		'top-bar' => 'Top Menu',
		'footer' => 'Footer Menu',
	));

}
endif;

function xinmag_widgets_init() {
	register_widget( 'xinmag_Recent_Post' );
	register_widget( 'xinmag_Navigation' );
	register_widget( 'xinmag_Social' );

	// Full Sidebar 
	register_sidebar( array(
		'name' => __( 'Blog Widget Area (Full)', 'xinmag' ),
		'id' => 'full-widget-area',
		'description' => __( 'Available for Left or Right sidebar layout.', 'xinmag' ),
		'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
		'after_widget' => '</li>',
		'before_title' => '<h4 class="widget-title">',
		'after_title' => '</h4>',
	) );	
	// First Sidebar - left or right
	register_sidebar( array(
		'name' => __( 'Blog Widget Area 1', 'xinmag' ),
		'id' => 'first-widget-area',
		'description' => __( 'Blog Widget Area 1', 'xinmag' ),
		'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
		'after_widget' => '</li>',
		'before_title' => '<h4 class="widget-title">',
		'after_title' => '</h4>',
	) );

	// Second Sidebar - left or right
	register_sidebar( array(
		'name' => __( 'Blog Widget Area 2', 'xinmag' ),
		'id' => 'second-widget-area',
		'description' => __( 'Blog Widget Area 2', 'xinmag' ),
		'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
		'after_widget' => '</li>',
		'before_title' => '<h4 class="widget-title">',
		'after_title' => '</h4>',
	) );

	// Header Widget Area
	register_sidebar( array(
		'name' => __( 'Header Widget Area', 'xinmag' ),
		'id' => 'header-widget-area',
		'description' => __( 'Header Widget Area', 'xinmag' ),
		'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
		'after_widget' => '</li>',
		'before_title' => '<h4 class="widget-title">',
		'after_title' => '</h4>',
	) );
	

	// Nav Widget Area
	register_sidebar( array(
		'name' => __( 'Navigation Widget Area', 'xinmag' ),
		'id' => 'nav-widget-area',
		'description' => __( 'Navigation Widget Area', 'xinmag' ),
		'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
		'after_widget' => '</li>',
		'before_title' => '<h4 class="widget-title">',
		'after_title' => '</h4>',
	) );

	// Home Widget Areas
	register_sidebar( array(
		'name' => __( 'Home Widget Area 1', 'xinmag' ),
		'id' => 'first-home-widget-area',
		'description' => __( 'Home Widget Area 1', 'xinmag' ),
		'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
		'after_widget' => '</li>',
		'before_title' => '<h4 class="widget-title">',
		'after_title' => '</h4>',
	) );
	register_sidebar( array(
		'name' => __( 'Home Widget Area 2', 'xinmag' ),
		'id' => 'second-home-widget-area',
		'description' => __( 'Home Widget Area 2', 'xinmag' ),
		'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
		'after_widget' => '</li>',
		'before_title' => '<h4 class="widget-title">',
		'after_title' => '</h4>',
	) );
	register_sidebar( array(
		'name' => __( 'Home Widget Area 3', 'xinmag' ),
		'id' => 'third-home-widget-area',
		'description' => __( 'Home Widget Area 3', 'xinmag' ),
		'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
		'after_widget' => '</li>',
		'before_title' => '<h4 class="widget-title">',
		'after_title' => '</h4>',
	) );
	register_sidebar( array(
		'name' => __( 'Home Widget Area 4', 'xinmag' ),
		'id' => 'fourth-home-widget-area',
		'description' => __( 'Home Widget Area 4', 'xinmag' ),
		'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
		'after_widget' => '</li>',
		'before_title' => '<h4 class="widget-title">',
		'after_title' => '</h4>',
	) );
	register_sidebar( array(
		'name' => __( 'Home Widget Area 5', 'xinmag' ),
		'id' => 'fifth-home-widget-area',
		'description' => __( 'Home Widget Area 5', 'xinmag' ),
		'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
		'after_widget' => '</li>',
		'before_title' => '<h4 class="widget-title">',
		'after_title' => '</h4>',
	) );

	// Footer Widgets
	register_sidebar( array(
		'name' => __( 'Footer Widget Area 1', 'xinmag' ),
		'id' => 'first-footer-widget-area',
		'description' => __( 'Footer Widget Area 1', 'xinmag' ),
		'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
		'after_widget' => '</li>',
		'before_title' => '<h5 class="widget-title">',
		'after_title' => '</h5>',
	) );

	register_sidebar( array(
		'name' => __( 'Footer Widget Area 2', 'xinmag' ),
		'id' => 'second-footer-widget-area',
		'description' => __( 'Footer Widget Area 2', 'xinmag' ),
		'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
		'after_widget' => '</li>',
		'before_title' => '<h5 class="widget-title">',
		'after_title' => '</h5>',
	) );

	register_sidebar( array(
		'name' => __( 'Footer Widget Area 3', 'xinmag' ),
		'id' => 'third-footer-widget-area',
		'description' => __( 'Footer Widget Area 3', 'xinmag' ),
		'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
		'after_widget' => '</li>',
		'before_title' => '<h5 class="widget-title">',
		'after_title' => '</h5>',
	) );

	register_sidebar( array(
		'name' => __( 'Footer Widget Area 4', 'xinmag' ),
		'id' => 'fourth-footer-widget-area',
		'description' => __( 'Footer Widget Area 4', 'xinmag' ),
		'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
		'after_widget' => '</li>',
		'before_title' => '<h5 class="widget-title">',
		'after_title' => '</h5>',
	) );
	// bbPress/BuddyPress Widget Area
	register_sidebar( array(
		'name' => __( 'bbPress/BuddyPress Widget Area', 'xinmag' ),
		'id' => 'bbp-widget-area',
		'description' => __( 'bbPress/BuddyPress Widget Area', 'xinmag' ),
		'before_widget' => '<li id="%1$s" class="widget-container %2$s">',
		'after_widget' => '</li>',
		'before_title' => '<h4 class="widget-title">',
		'after_title' => '</h4>',
	) );
}
/** Register sidebars by running xinmag_widgets_init() on the widgets_init hook. */
add_action( 'widgets_init', 'xinmag_widgets_init' );

if ( ! function_exists( 'xinmag_header_style' ) ) :
function xinmag_header_style() {
	$text_color = get_header_textcolor();
	if ( $text_color == HEADER_TEXTCOLOR ) //Default Text Color. Doing Nothing
		return;
?>
<style type="text/css">
<?php
	if ( 'blank' == $text_color ) { // Blog Text is unchecked
?>
#site-title,
#site-description {
	position: absolute !important;
	clip: rect(1px 1px 1px 1px); /* IE6, IE7 */
	clip: rect(1px, 1px, 1px, 1px);
}
<?php
	} else { // Custom color
?>
#site-title a,
#site-description {
	color: #<?php echo $text_color; ?> !important;
}
<?php
	}
?>
</style>
<?php
}
endif;

if ( ! function_exists( 'xinmag_comment' ) ) :
function xinmag_comment( $comment, $args, $depth ) {
	$GLOBALS['comment'] = $comment;
	switch ( $comment->comment_type ) {
		case 'pingback' :
		case 'trackback' :
	?>
	<li class="post pingback">
		<p><?php _e( 'Pingback:', 'xinmag' ); ?> <?php comment_author_link(); ?><?php edit_comment_link( '<i class="icon-pencil"></i> ' . __( '[Edit]', 'xinmag' ), ' ' ); ?></p>
	<?php
			break;
		default :
	?>
	<li <?php comment_class(); ?> id="li-comment-<?php comment_ID(); ?>">
		<article id="comment-<?php comment_ID(); ?>" class="comment">
			<footer>
				<div class="comment-meta">
<?php 				echo get_avatar( $comment, 40 );
					printf( '<cite class="fn">%1$s</cite>', get_comment_author_link() );  ?>
					<a href="<?php echo esc_url( get_comment_link( $comment->comment_ID ) ); ?>"><time pubdate datetime="<?php comment_time( 'c' ); ?>">
					<?php
						printf( __( '%1$s at %2$s', 'xinmag' ), get_comment_date(), get_comment_time() ); ?>
					</time></a>
					<?php edit_comment_link( '<i class="icon-pencil"></i> ' . __( '[Edit]', 'xinmag' ), ' ' );					
					if ( $comment->comment_approved == '0' ) { ?>
					<em><?php _e( 'Your comment is awaiting moderation.', 'xinmag' ); ?></em>
<?php 				}; ?>
				</div>
			</footer>
			<div class="comment-content"><?php comment_text(); ?></div>
			<div class="reply">
				<?php comment_reply_link( array_merge( $args, array( 'depth' => $depth, 'max_depth' => $args['max_depth'] ) ) ); ?>
			</div>
		</article>
	<?php
			break;
	}
}
endif;

function xinmag_excerpt_length( $length ) {
	return 40;
}
add_filter( 'excerpt_length', 'xinmag_excerpt_length' );

/**
 * Returns a "Continue Reading" link for excerpts
 *
 */
function xinmag_continue_reading_link() {
	global $post;
	$readmore = get_post_meta( $post->ID, '_xinmag_readmore', true );
	if ( empty( $readmore ) )
		$readmore = __( 'read more', 'xinmag' );
	$link = ' <a class="more-link" href="'. get_permalink() . '">' . $readmore . '</a>';
	return $link;
}

function xinmag_auto_excerpt_more( $more ) {
	return ' &hellip;';
}
add_filter( 'excerpt_more', 'xinmag_auto_excerpt_more' );

function xinmag_custom_excerpt_more( $output ) {
	if ( ! is_attachment() ) {
		$output .= xinmag_continue_reading_link();
	}
	return $output;
}
add_filter( 'get_the_excerpt', 'xinmag_custom_excerpt_more' );

if ( ! function_exists( 'xinmag_content_nav' ) ) :
/**
Pagination for main loop
 */
function xinmag_content_nav( $nav_id ) {
	global $wp_query;
	xinmag_content_nav_link( $wp_query->max_num_pages, $nav_id );
}
endif;

if ( ! function_exists( 'xinmag_content_nav_link' ) ) :
/**
Pagination 
 */
function xinmag_content_nav_link( $num_of_pages, $nav_id ) {
	if ( $num_of_pages > 1 ) {
		echo '<nav id="' . $nav_id . '" class="pagination-centered">';
		echo '<ul class="pagination">';

		$big = 999999999;
    	if ( get_query_var( 'paged' ) )
	    	$current_page = get_query_var( 'paged' );
		elseif ( get_query_var( 'page' ) ) 
	   	 	$current_page = get_query_var( 'page' );
		else 
			$current_page = 1;
		$links =  paginate_links( array(
			'base' => str_replace( $big, '%#%', esc_url( get_pagenum_link( $big ) ) ),
			'format' => '?paged=%#%',
			'current' => max( 1, $current_page ),
			'total' => $num_of_pages,
			'mid_size' => 3,
			'prev_text'    => '<i class="icon-chevron-left"></i>' ,
			'next_text'    => '<i class="icon-chevron-right"></i>' ,
			'type' => 'array' ) );
			
		echo '<li><span>' . __( 'Page ', 'xinmag' ) . '</span></li>';
		foreach ( $links as $link )
			printf( '<li>%1$s</li>', $link );
		echo '</ul></nav>';					
	}
}
endif;

/**
 * Replace rel="category tag" with rel="tag"
 * For W3C validation purposes only.
 */
function xinmag_replace_rel_category ($output) {
    $output = str_replace(' rel="category tag"', ' rel="tag"', $output);
    return $output;
}
add_filter('wp_list_categories', 'xinmag_replace_rel_category');
add_filter('the_category', 'xinmag_replace_rel_category');

if ( ! function_exists( 'xinmag_meta_category' ) ) :
// Prints Post Categories
function xinmag_meta_category() {
	$categories = wp_get_post_categories( get_the_ID() , array('fields' => 'ids'));
	if( $categories ) {
 		$sep = ' &bull; ';
 		$cat_ids = implode( ',' , $categories );
 		$cats = wp_list_categories( 'title_li=&style=none&echo=0&include='.$cat_ids);
 		$cats = rtrim( trim( str_replace( '<br />',  $sep, $cats) ), $sep);
		echo '<span class="entry-category">';
		echo '<span class="meta-prep"><i class="icon-folder-open meta-icon"> </i></span>';	
 		echo  $cats;
		echo '</span>';
	}
}
endif;

if ( ! function_exists( 'xinmag_meta_author' ) ) :
function xinmag_meta_author() {
	printf( '<span class="by-author"><a class="url fn n" href="%1$s" title="%2$s" rel="author"><span class="meta-prep">%4$s</span> %3$s</a></span>',
		esc_url( get_author_posts_url( get_the_author_meta( 'ID' ) ) ),
		esc_attr( sprintf( __( 'View all posts by %s', 'xinmag' ), get_the_author() ) ),
		get_the_author(),
		'<i class="icon-user meta-icon"> </i>' );
	
}
endif;


if ( ! function_exists( 'xinmag_meta_comment' ) ) :
// Prints Comments Link
function xinmag_meta_comment() {
	if ( comments_open() && ! post_password_required() ) {
		$comment_icon = '<i class="icon-comment meta-icon"> </i>';
		printf( '<span class="meta-comment">' );
		comments_popup_link( $comment_icon, $comment_icon . __( '1 Comment', 'xinmag' ) , $comment_icon . __( '% Comments', 'xinmag' ) );		
		printf( '</span>' );
	}
}
endif;

if ( ! function_exists( 'xinmag_meta_date' ) ) :
// Prints Post Date
function xinmag_meta_date( $style = 1) {
	if ( 1 == $style ) {
		echo '<p class="post-date-2">';
		echo '<span class="month">' . get_the_date('M') . '</span>';
		echo '<span class="day">' . get_the_date('j') . '</span>';
		echo '<span class="year">' . get_the_date('Y') . '</span></p>';
	} elseif ( 2 == $style ) {
		echo '<i class="icon-calendar meta-icon"> </i>';
		printf( __( '<time class="entry-date" datetime="%1$s">%2$s</time>', 'xinmag' ),
			esc_attr( get_the_date( 'c' ) ),
			esc_html( get_the_date() ) );				
	} 
}
endif;

if ( ! function_exists( 'xinmag_meta_tag' ) ) :
// Prints Post Tags
function xinmag_meta_tag() {
	$tags_list = get_the_tag_list( '', __( ' &bull; ', 'xinmag' ) );
	if ( $tags_list ) {
		echo '<i class="icon-tags meta-icon"> </i>';
		printf( '<span class="entry-tag">%1$s</span>',
		$tags_list );
	} 
}
endif;

if ( ! function_exists( 'xinmag_post_meta' ) ) :
function xinmag_post_meta() {
	if ( 'post' == get_post_type() ) {
		echo '<span class="entry-meta">';		
		if ( is_sticky() ) {
			printf( '<span class="entry-featured">%1$s </span>', __( 'Featured ', 'xinmag') );
		}
		xinmag_meta_author();
		xinmag_meta_category();
		xinmag_meta_comment();			
		echo '</span>';	
	}
}
endif;

if ( ! function_exists( 'xinmag_post_tag' ) ) :
// Prints tages, edit link at the bottom of the post
function xinmag_post_tag() {
	printf ('<div class="entry-meta entry-meta-bottom">');	
	if ( 'post' == get_post_type() )
		xinmag_meta_tag();
/*	if ( is_singular() && ! is_home() )
		printf( __(' <a href="%1$s" title="Permalink to %2$s" rel="bookmark">Permalink</a>', 'xinmag' ),
				esc_url( get_permalink() ),
				the_title_attribute( 'echo=0' )
			); */
	edit_post_link( '<i class="icon-pencil"></i> ' . __( '[Edit]', 'xinmag' ), '<span class="edit-link">', '</span>' );
	echo '</div>';	
}
endif;

if ( ! function_exists( 'xinmag_post_summary_meta' ) ) :
// Prints meta info for Post Summary
function xinmag_post_summary_meta( $meta_flag = 0 ) {
	global $xinmag_entry_meta;
	
	echo '<div class="entry-meta entry-meta-summary clearfix">';
	if ( ( $xinmag_entry_meta || $meta_flag ) && 'post' == get_post_type() ) {
		xinmag_meta_date( 2 );
		xinmag_meta_author();
		xinmag_meta_category();
		xinmag_meta_tag();
		xinmag_meta_comment();
	}
	edit_post_link( '<i class="icon-pencil"></i> ' . __( '[Edit]', 'xinmag' ), '<span class="edit-link">', '</span>' );	
	echo '</div>';	
}
endif;

function xinmag_body_classes( $classes ) {
	global $xinmag_options, $xinmag_layout;
			
	if ( ! is_single() )
		$classes[] = 'multi';
	elseif ( 2 == $xinmag_layout )
		$classes[] = 'fullscreen';
	return $classes;
}
add_filter( 'body_class', 'xinmag_body_classes' );

function xinmag_scripts_method() {	
	global $xinmag_options, $xinmag_fonts;
	
	$theme_uri = get_template_directory_uri();
	// Check if the fonts are webfont, if yes, load the font.
	$xinmag_fonts = xinmag_fonts_array();
	$font_elements = array(
			'bodyfont','headingfont','entrytitlefont',
			'sitetitlefont','sitedescfont', 'mainmenufont',
			'sidebarfont', 'widgettitlefont', 'footerfont'
	);
	$fonts = array();
	foreach ( $font_elements as $element ) {
		if ( $xinmag_options[$element] > 0
				&& ! in_array( $xinmag_options[ $element ], $fonts) )
			$fonts[] = $xinmag_options[ $element ];		
	}

	foreach ( $fonts as $font ) {
		if ( ! empty( $xinmag_fonts[ $font ]['url'] ) )
			wp_enqueue_style( str_replace(' ', '', $xinmag_fonts[ $font ]['label']), $xinmag_fonts[ $font ]['url'], false, 1.0 );
	}
	
	wp_enqueue_style('xinmagaddons', $theme_uri . '/css/addons.min.css', false, xinmag_VERSION);
	wp_enqueue_style('foundation', $theme_uri . '/dev/foundation.css', array( 'xinmagaddons' ), '4.1.7');
	wp_enqueue_style('xinmag', $theme_uri . '/dev/xinmag.css', array( 'foundation', 'xinmagaddons' ), xinmag_VERSION);
	$child_pre = array( 'xinmag' );
	// Load Scheme CSS
	if ( ! empty( $xinmag_options['schemecss'] ) ) {
		wp_enqueue_style('xinmag-scheme', $xinmag_options['schemecss'], $child_pre, xinmag_VERSION );
		$child_pre[] = 'xinmag-scheme';		
	}
	//Load child theme's style.css
    if ( $theme_uri != get_stylesheet_directory_uri() )
		wp_enqueue_style('xinmag-child', get_stylesheet_uri(), $child_pre, xinmag_VERSION );

	// Page Template specific
	if ( is_page_template( 'pages/portfolio.php' ) ) {
		wp_enqueue_script( 'infinite-scroll' , $theme_uri . '/js/jquery.infinitescroll.min.js', array( 'jquery-masonry' ), '2.0', true );	
		$xinmag_dep[] = 'infinite-scroll';
	}		
	//Scripts
	if ( is_singular() && get_option( 'thread_comments' ) )
		wp_enqueue_script( 'comment-reply' );	
	wp_enqueue_script( 'modernizr' , $theme_uri . '/js/custom.modernizr.js', null );
	wp_enqueue_script( 'easing' , $theme_uri . '/js/jquery.easing.js', array( 'jquery'), null, true );
	wp_enqueue_script( 'foundation' , $theme_uri . '/js/foundation.min.js', array( 'jquery'), '4.1.7', true );
	wp_enqueue_script( 'flexslider' , $theme_uri . '/js/jquery.flexslider-min.js', array( 'jquery'), '2.0', true );

	wp_enqueue_script( 'xinmag' , $theme_uri . '/js/xinmag.js', array( 'foundation', 'flexslider'), xinmag_VERSION, true );
}
if ( ! is_admin() )
	add_action( 'wp_enqueue_scripts', 'xinmag_scripts_method' ); 

require( get_template_directory() . '/inc/hooks.php' );
require( get_template_directory() . '/inc/lib-foundation.php' );
require( get_template_directory() . '/inc/lib-general.php' );
require( get_template_directory() . '/inc/lib-functions.php' );
require( get_template_directory() . '/inc/lib-content.php' );
require( get_template_directory() . '/inc/widgets.php' );
require( get_template_directory() . '/scheme/scheme.php' );
if ( is_admin() ) {
	require( get_template_directory() . '/inc/lib-admin.php' );
	require( get_template_directory() . '/inc/theme-options.php' );
}

$xinmag_options = xinmag_get_options(); //Global Theme Options
