<?php 
if ( ! defined( 'ABSPATH' ) ) exit;
/**
 * Admin related functions
 *
 * @package xinmag
 * @since xinmag 1.0
 */
if ( ! function_exists( 'xinmag_admin_header_style' ) ) :
function xinmag_admin_header_style() {
?>
<style type="text/css">
.appearance_page_custom-header #headimg {
	background-repeat:no-repeat;
	border: none;
}
#headimg h1,
#desc {
	font-family: "Helvetica Neue", Arial, Helvetica, "Nimbus Sans L", sans-serif;
}
#headimg h1 {
	margin: 0;
}
#headimg h1 a {
	font-size: 32px;
	line-height: 36px;
	text-decoration: none;
}
#desc {
	font-size: 14px;
	line-height: 23px;
	padding: 0 0 3em;
}
<?php
	if ( HEADER_TEXTCOLOR != get_header_textcolor() ) {
?>
#site-title a,
#site-description {
	color: #<?php echo get_header_textcolor(); ?>;
}
<?php } ?>
</style>
<?php
}
endif;

if ( ! function_exists( 'xinmag_admin_header_image' ) ) :
function xinmag_admin_header_image() { ?>
<div id="headimg">
<?php
	$color = get_header_textcolor();
	$image = get_header_image();
	if ( $color && $color != 'blank' )
		$style = ' style="color:#' . $color . '"';
	else
		$style = ' style="display:none"';
?>
	<?php if ( $image ) : ?>
			<img src="<?php echo esc_url( $image ); ?>" alt="" />
	<?php endif; ?>
	<h1><a id="name"<?php echo $style; ?> onclick="return false;" href="<?php echo esc_url( home_url( '/' ) ); ?>"><?php bloginfo( 'name' ); ?></a></h1>
	<div id="desc"<?php echo $style; ?>><?php bloginfo( 'description' ); ?></div>
</div>
<?php
}
endif;

//Add meta boxes to page/post
function xinmag_meta_box() {
	global $xinmag_meta_box;
	
	$xinmag_meta_box['page'] = array( 
		'id' => 'xinmag-page-meta',
		'title' => __('Template Options (xinmag)', 'xinmag'),  
		'context' => 'side',  //normal, advaned, side  
		'priority' => 'low', //high, core, default, low
		'fields' => array(
        	array(
            	'name' => __('Post Category :','xinmag'),
            	'desc' => '',
            	'id' => '_xinmag_category',
            	'type' => 'category',
            	'default' => ''
        	),
        	array(
            	'name' => __( 'Posts per page :', 'xinmag' ),
            	'desc' => '',
            	'id' => '_xinmag_postperpage',
            	'type' => 'number',
            	'default' => '',
        	),
        	array(
            	'name' => __('Page Title :', 'xinmag'),
            	'desc' => __('check to hide page title','xinmag'),
            	'id' => '_xinmag_title',
            	'type' => 'checkbox',
            	'default' => '',
        	),
			array(
            	'name' => __('Sidebar :', 'xinmag'),
            	'desc' => __('check to display sidebar','xinmag'),
            	'id' => '_xinmag_sidebar',
            	'type' => 'checkbox',
            	'default' => '',
        	),
        	array(
            	'name' => __('Layout :', 'xinmag'),
            	'desc' => __('Columns','xinmag'),
            	'id' => '_xinmag_column',
            	'type' => 'select',
            	'default' => '',
				'options' => array( 
								array( 'key' => '1',
									   'name' => '1' ),
								array( 'key' => '2', 
									   'name' => '2' ),
								array( 'key' => '', //Dedault
									   'name' => '3' ),
								array( 'key' => '4', 
									   'name' => '4' ),
							 ),
        	),
        	array(
            	'name' => __('Image Size : ', 'xinmag'),
            	'desc' => '',
            	'id' => '_xinmag_thumbnail',
            	'type' => 'select',
            	'default' => '',
				'options' => xinmag_thumbnail_array(),
        	),
        	array(
            	'name' => __('Custom Size (Width) :', 'xinmag'),
            	'desc' => '',
            	'id' => '_xinmag_size_x',
            	'type' => 'number',
            	'default' => '',
        	),
        	array(
            	'name' => __('Custom Size (Height) :', 'xinmag'),
            	'desc' => '',
            	'id' => '_xinmag_size_y',
            	'type' => 'number',
            	'default' => '',
        	),
        	array(
            	'name' => __('Intro Text : <br />', 'xinmag'),
            	'desc' => '',
            	'id' => '_xinmag_intro',
            	'type' => 'radio',
            	'default' => '',
				'options' => array( 
								array( 'key' => '',
									   'name' => __('Excerpt<br />','xinmag') ),
								array( 'key' => '2', 
									   'name' => __('Content<br />','xinmag') ),
								array( 'key' => '3', 
									   'name' => __('None<br />','xinmag') ),
							 ),
        	),
        	array(
            	'name' => __('Post Meta :', 'xinmag'),
            	'desc' => __('check to display post meta','xinmag'),
            	'id' => '_xinmag_disp_meta',
            	'type' => 'checkbox',
            	'default' => '',
        	),
        	array(
            	'name' => 'Data',
            	'desc' => 'Data',
            	'id' => '_xinmag_pt_data',
            	'type' => 'hidden',
            	'default' => '',
        	),
    	)
	);
	$xinmag_meta_box['post'] = array( 
		'id' => 'xinmag-post-meta',
		'title' => __('xinmag Post Options', 'xinmag'),  
		'context' => 'side',  //normal, advaned, side  
		'priority' => 'high', //high, core, default, low
		'fields' => array(
        	array(
            	'name' => __('Layout :', 'xinmag'),
            	'desc' => '',
            	'id' => '_xinmag_layout',
            	'type' => 'select',
            	'default' => '',
				'options' => array( 
					array( 'key' => '', //Dedault
						   'name' => __( 'Default', 'xinmag' ) ),
					array( 'key' => '1', 
						   'name' => __( 'Fullwidth', 'xinmag' ) ),
					array( 'key' => '2', 
						   'name' => __( 'Fullscreen', 'xinmag' ) ) ),
        	),			
        	array(
            	'name' => '',
            	'desc' => __('Featured Post','xinmag'),
            	'id' => '_xinmag_featured',
            	'type' => 'checkbox',
            	'default' => '',
        	),
        	array(
            	'name' => __('Read More Label :', 'xinmag'),
            	'desc' => '',
            	'id' => '_xinmag_readmore',
            	'type' => 'text',
            	'default' => '',
        	),
    	)
	);

    foreach( $xinmag_meta_box as $post_type => $value ) {
    	add_meta_box( $value['id'], $value['title'], 'xinmag_meta_display', $post_type, $value['context'], $value['priority'] );
    }
}
add_action( 'admin_menu', 'xinmag_meta_box' );

//Display Meta Box
function xinmag_meta_display() {
	global $xinmag_meta_box, $post;
 
	// Use nonce for verification
	echo '<input type="hidden" name="xinmag_meta_box_nonce" value="', wp_create_nonce( basename( __FILE__ ) ), '" />';
 
	foreach ( $xinmag_meta_box[ $post->post_type ]['fields'] as $field ) {
		$meta = get_post_meta( $post->ID, $field['id'], true);

		if ('hidden' != $field['type'] )
			echo '<p id="p' . $field['id'] . '"><strong>' . $field['name'] . ' </strong>';

		switch ( $field['type'] ) {
			case 'text':
				echo '<input type="text" name="' . $field['id'] . '" id="' . $field['id'] . '" value="' . ( $meta ? $meta : $field['default'] ) . '" size="30" />';
				break;
			case 'hidden':
				echo '<input type="hidden" name="' . $field['id'] . '" id="' . $field['id'] . '" value="' . ( $meta ? $meta : $field['default'] ) . '" />';
				break;
			case 'textarea':
				echo '<textarea name="' . $field['id'] . '" id="'. $field['id'] . '" cols="60" rows="4" >' . ( $meta ? $meta : $field['default'] ) . '</textarea>' . '<br />' . $field['desc'];
				break;
			case 'number':
				echo '<input type="text" name="' . $field['id'] . '" id="' . $field['id'] . '" value="' . ( $meta ? $meta : $field['default'] ) . '" size="4" />';
				break;
			case 'select':
				echo '<select name="'. $field['id'] . '" id="'. $field['id'] . '">';
				foreach ( $field['options'] as $option ) {
					echo '<option value="' . $option['key'] . '" ' . ( $meta == $option['key'] ? ' selected="selected"' : '' ) . '>' . $option['name'] . '</option>';
				}
				echo '</select> ' . $field['desc'];
				break;
			case 'category':
				echo '<select name="'. $field['id'] . '" id="'. $field['id'] . '">';		  
				echo '<option value="" ' . ( $meta ? '' : 'selected="selected"' ) . '>' . __('All Categories','xinmag') . '</option>';
				foreach ( xinmag_categories() as $category ) {
					echo '<option value="' . $category->term_id . '" ' . ( $meta == $category->term_id ? ' selected="selected"' : '' ) . '>' . $category->name . '</option>';
				}
				echo '</select>';
				break;
			case 'radio':
				foreach ( $field['options'] as $option ) {
					echo '<label class="description"><input type="radio" name="' . $field['id'] . '" value="' . $option['key'] . '"' . ( $meta == $option['key'] ? ' checked="checked"' : '' ) . ' /> ' . $option['name'] . '</label>';
				}
				break;
			case 'checkbox':
				echo '<label class="description"><input type="checkbox" name="' . $field['id'] . '" id="' . $field['id'] . '" value="1"' . ( $meta ? ' checked="checked"' : '' ) . ' /> ' . $field['desc'] . '</label>';
				 break;
		}
		echo '</p>';
	}
}
// Save data from meta box
function xinmag_meta_save( $post_id ) {
    global $xinmag_meta_box,  $post;
    
    //Verify nonce
	if ( ! isset( $_POST['xinmag_meta_box_nonce'] ) )
		return $post_id;
	if ( ! wp_verify_nonce( $_POST['xinmag_meta_box_nonce'], basename( __FILE__ ) ) )
        return $post_id; 
    //Check autosave
    if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE )
        return $post_id;
 
    //Check permissions
    if ( 'page' == $_POST['post_type'] ) {
        if ( ! current_user_can( 'edit_page', $post_id ) )
            return $post_id;
    } elseif ( ! current_user_can( 'edit_post', $post_id ) ) {
        return $post_id;
    }
    
    foreach ( $xinmag_meta_box[ $post->post_type ]['fields'] as $field ) {
        $old = get_post_meta( $post_id, $field['id'], true );
		if ( isset( $_POST[ $field['id'] ] ) ) {
			$new = $_POST[ $field['id'] ];
			if ( $field['type'] == 'number')
				$new = (int) $new;
		}
		else
        	$new = '';			

        if ( $new && $new != $old )
            update_post_meta( $post_id, $field['id'], $new );
        elseif ( '' == $new && $old )
            delete_post_meta( $post_id, $field['id'], $old );
    }
}
add_action( 'save_post', 'xinmag_meta_save' );

function xinmag_load_template_scripts( $hooks ) {
	global $post_type;

	$tmp_path = get_template_directory_uri();
	
	if ( 'page' == $post_type ) {
		wp_enqueue_script( 'xinmag-template', $tmp_path . '/js/template.js', array( 'jquery') );	
	}
	if ( 'widgets.php' == $hooks ) {
		wp_enqueue_style( 'xinmag-widgets', $tmp_path . '/css/widgets.css', null, '1.0' );	
		wp_enqueue_script( 'xinmag-widgets', $tmp_path . '/js/widgets.js', array( 'jquery-ui-sortable' ) );			
	}
}
add_action( 'admin_enqueue_scripts', 'xinmag_load_template_scripts' );
